/***************************************************************************
 *   Copyright (C) 2000 2008 by Michael Rapaport   *
 *   rucko4t@yahoo.com   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DRAUGHTVIEW_H
#define DRAUGHTVIEW_H
#include "draught.h"
#include <qcanvas.h>
#include <qevent.h>


/**
 * @author pop <rucko4t@yahooo.com>
 * @version 5.8
*/

const  int a[]={0,2,4,6,9,11,13,15,16,18,20,22,25,27,29,31,32,34,36,38,41,43,45,47,48,50,52,54,57,59,61,63,};

class draughtView : public QCanvasView {
    Q_OBJECT
  KStatusBar*          sbar;                       // shortcut to KSimulate's statusbar

    draught* draft;
    QCanvasItem* moving;
    QCanvasText* statuss;
    QCanvasText* errors;
    QCanvasText* scoreTop;
    QCanvasText* scoreBot;
    QCanvasText* draws;
    QCanvasText* gamesPlayed;
    int piec,piece,OSloc,old,endLoc;  
    int Sloc,Dloc;

#define MAXHIST 600
#define INVALID 5            // White space no man land
#define NOMAN   4	     // Legal space no man present
#define MANA    0            // Top Man  pink ,,computer man
#define MANB    1            // bottom man. blue ,, human man
#define KINGA   2
#define KINGB   3
#define STOP	-1

#define PARTIAL 1
#define FINAL	2
#define AMBIG	32
#define ATAKE	0
#define NOTAKE	-1

unsigned int *pb;
uint64_t ems,eks,cms,cks;
unsigned int move[24];          // possibilities of moves
int pskip,pSloc;     		//*pb,
					//int innugame,num_moves_no_cap_or_man_move,fst;
int fst;
int start_x,start_y,end_x,end_y;
QPoint moving_start;    		//,beginDrag;

    void erase_item(int loc);
    void erase_item(int x,int y);
    void get_star(int loc);
    void write_item(int loc,int who);
    int promotion(int side);
    void write_piece(int loc,int who);
    void erase_sq(int loc);
    void erase_piece(int loc,int tipe);
    int position(int the_x,int the_y);
    int LSBL(uint64_t  value);
    int MSBL(uint64_t  value);
    int Kmove(int Sm,int Dm);
    int isMtakes();
    int MtakesLgl(unsigned int *pbest,int man,int dest);
    int ppMtakesLgl(unsigned int *pbest,int man,int dest,int numtake,int e);
    int isKtakes();
    int KtakesLgl(unsigned int *pbest,int skip,int sq,int dest);
    int ppKtakesLgl(unsigned int *pbest,int skip,int sq,int dest,int e);
    int check_it(int Sloc,int Dloc,int tipe);
    void updateThem(int Sloc,int Dloc,int tipe);

 protected:
 
virtual    void contentsMousePressEvent(QMouseEvent*);
virtual    void contentsMouseMoveEvent(QMouseEvent*);
virtual    void contentsMouseReleaseEvent(QMouseEvent*);

signals:
    void status(const QString&);

public:
        draughtView( QCanvas*, draught*);              // constructor
        ~draughtView();
     	void clear();
	void reset_score();
     	void initialiser(bool nue);
	void atoInitialiser();
     	void myBoard();
        void myPieces();
        int which( int loc);
	void get_xy(int *xie,int *yie,int loc);
    	void OnForward();
        void OnBack();
	bool OnTrain();
	void OnPlay();
	bool movfime;
        void turnchange(int t);
	unsigned int movelist1[12];
	int whowin;
	bool hover,hoover;              //,black_on_top;
        void resetHash();
        void OnScramble();
	void On_def_Brain();
void show_current_Brain();
unsigned int *phist,*cp,*phistB,*plastHist,*pmaxHist,jucks; 
bool Ato,nugame,Amenfirst,muted;
int inc,border,ofsetxy;
int wins[3]; 
void customEvent( QCustomEvent * e );
int take;
bool killer,speed;
	struct them
					{
					unsigned int Hist[MAXHIST];
					uint64_t compmen,enemymen,compkings,enemykings;
					bool cpturn,PlayAmen,black_on_top;
					unsigned int lasthist,curhist; //=plastHist-Hist //  phist-Hist
					}pieces;
  void makemove();
  void atomove();
  void stall();                   //waste time

 };

#endif

